package com.agilecontrol.nea.core.security;

import com.agilecontrol.nea.core.security.UrlSafeBase64;
import java.security.SecureRandom;
import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;

public class DESUtil {

   public static final String KEY_ALGORITHM = "DES";
   public static final String CIPHER_ALGORITHM = "DES/ECB/NoPadding";


   private static SecretKey keyGenerator(String keyStr) throws Exception {
      byte[] input = HexString2Bytes(keyStr);
      DESKeySpec desKey = new DESKeySpec(input);
      SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
      SecretKey securekey = keyFactory.generateSecret(desKey);
      return securekey;
   }

   private static int parse(char c) {
      return c >= 97?c - 97 + 10 & 15:(c >= 65?c - 65 + 10 & 15:c - 48 & 15);
   }

   public static byte[] HexString2Bytes(String hexstr) {
      byte[] b = new byte[hexstr.length() / 2];
      int j = 0;

      for(int i = 0; i < b.length; ++i) {
         char c0 = hexstr.charAt(j++);
         char c1 = hexstr.charAt(j++);
         b[i] = (byte)(parse(c0) << 4 | parse(c1));
      }

      return b;
   }

   public static String encrypt(String data, String key) throws Exception {
      SecretKey deskey = keyGenerator(key);
      Cipher cipher = Cipher.getInstance("DES/ECB/NoPadding");
      SecureRandom random = new SecureRandom();
      cipher.init(1, deskey, random);
      int rem = data.length() % 8;
      if(rem != 0) {
         for(int results = 0; results < 8 - rem; ++results) {
            data = data.concat(" ");
         }
      }

      byte[] var7 = cipher.doFinal(data.getBytes());
      return UrlSafeBase64.encodeToString((byte[])var7);
   }

   public static String decrypt(String data, String key) throws Exception {
      SecretKey deskey = keyGenerator(key);
      Cipher cipher = Cipher.getInstance("DES/ECB/NoPadding");
      cipher.init(2, deskey);
      return (new String(cipher.doFinal(UrlSafeBase64.decode(data)))).trim();
   }

   public static void main(String[] args) throws Exception {
      String source = "Nby-lHU9eLs=";
      System.out.println("原文: " + source);
      String key = "lifecycle.cn.encrypt.key";
      String decryptData = decrypt(source, key);
      System.out.println("解密后: " + decryptData);
   }
}
